/* The cart in the header */

.header--cart{
  position: relative;
  z-index: 50;

  // Always shown
  &--link {

    a {
      line-height: 1;
      padding: 0.975rem 1rem;
      font-weight: 700;
      text-decoration: none;
      display: block;

      &:hover{
        text-decoration: none;
        color: inherit;
      }
    }

    // The count in the header cart
    .counted {
      display: inline-block;
      margin-right: 0.25rem;
    }
  }

  @include not-wider-than( tablet ){

    .cart-is-empty & {
      display: none;
    }

    @at-root {
      .header ~ .header {
        position: relative;
      }

      body:not(.cart-is-empty) .header ~ .header {
        margin-bottom: 3rem;
      }
    }

    position: absolute;
    left: 0;
    top: 100%;
    width: 100%;
    padding: 0rem 1rem;
    background-color: $grey-dark;
    color: white;

    &--link {
      padding: 0.65rem 1.5rem;

      a{
        color: white;
      }
    }
  }

  &--container {
    top: 100%;
    z-index: 10;
    background-color: white;
    box-shadow: 0 4px 7px -1px fade-out( black, 0.7 );
    border: 1px solid $grey-line;
    padding: 1rem;
    right: 0;
    position: absolute;
    width: 22rem;
    min-width: 20vw;
    display: none;

    &.open{
      display: block;
    }
    // Incase we dont want to slide,
    // swap JS for anything
    .js-off-menu & {
      overflow: hidden;
      top: 0;
      right: -100%;
      position: fixed;
      height: 100%;
      width: 22rem;
      min-width: 27vw;

      $speed: 0.42s;
      $ease: cubic-bezier( .04,.56,.71,.99 );
      &.open {
        animation: slide--in__right $speed $ease forwards;
      }

      .cart__inactive & {
        animation: slide--out__right 1s $ease forwards;
      }
    }

  }

  &--title{
    text-align: center;
    h3{ margin-bottom: 1rem; }
  }

  &--scroll{
    position: relative;
    width: 100%;
    height: 12rem;
    .js-off-menu & {
      height: 100%;
    }

  }

  // The cart dropdown
  &--list{
    width: 100%;
    display: block;

    .js & {
      position: absolute;
      top: 0;
      left: 0;
      height: 100%;
      overflow-y: scroll;
      background-color: white;
      padding-bottom: 4rem;
    }

    .js-off-menu & {
      height: 60%;
      height: calc( 100% - 11.5rem );
    }


    tbody{
      width: 100%;
      display: table;
    }

    @at-root .empty-cart{
      text-align: center;
    }
  }

  // Individual items within the cart
  &--item {
    width: 100%;
    display: block;
    position: relative;

    &:not(:only-child):not(:first-child) {
      td { border-top: 1px solid fade-out( black, 0.75 ); }
    }
    td {
      vertical-align: top;
      $table-padding: 0.5rem;
      padding: $table-padding 0;
      &:first-child{ padding-left: $table-padding; }
      &:last-child{ padding-right: $table-padding; }
    }

    // Product image
    &--img{
      vertical-align: top;
      width: 16%;

      a { display: block; }

      img{
        width: 100%;
        height: auto;
        max-width: 4rem;
        max-height: 4rem;
        @include object-fit( contain );
        padding: 2px;
        border: 1px solid $grey-line;
        overflow: hidden;
      }
    }

    &--details{
      width: 59%;
      padding: 0 0.5rem;
      vertical-align: top;
      text-align: left;

      .js-off-menu & {
        width: auto;
        padding-right: 0.25rem;
      }
    }

    // SKU
    &--meta{
      color: $text;
      margin: 0;
      &:empty{ display: none; }
    }

    &--name{
      color: $text;
      padding-left: 1rem;
      display: inline-block;
      font-size: 0.8rem;
      text-decoration: none;

      a {
        text-decoration: none;
        color: $text;
        font-size: 0.8rem;
      }
    }

    &--title{
      a {
        text-decoration: none;
        color: $text;
        font-size: 0.8rem;
      }
    }

    &--cost{
      width: 25%;
      vertical-align: middle;
      .js-off-menu &{
        vertical-align: top;
      }
    }

    overflow: hidden;
    &:hover {
      .header--cart--item--options{
        left: 0;
        transition: left 0.45s $curve;
      }
    }

    // Price + input qty
    &--price,
    &--quantity, {
      vertical-align: middle;
      display: inline-block;
      text-align: right;

      input{
        width: 100%;
        padding: 0.25rem;
      }
    }
  }

  .item--quantity{
    text-align: center;
    font-size: 0.8rem;

    .js-off-menu &{
      border: 0;
    }
  }

  &--subtotal{
    border-top: 1px solid $grey-line;
    background-color: white;
    width: 100%;
    padding: 1rem;
    text-align: center;

    .js-off-menu & {
      position: absolute;
      bottom: 4rem;
      right: 0;
      // Fade out the bottom of the list to
      // show there are more to see.
      box-shadow: 0 -3rem 4rem 1rem white;
    }
  }

  &--sub{
    &:first-child {
      padding-right: 1rem;
      font-weight: 700;
    }
  }


  &--checkout{
    border-top: 1px solid $grey-line;
    background-color: white;
    position: absolute;
    bottom: 0;
    right: 0;
    width: 100%;
    padding: 1rem;
    text-align: center;
  }

  &--btn{
    padding: 0.5rem 1rem;
    @include span( 6, 12, 0.75rem);
    text-decoration: none;
    color: white;
    & ~ & {
      margin-right: 0;
    }
  }
}

.btn--cart{
  background-color: $alert-blue;
  &:visited{
    text-decoration: none;
  }
}
.btn--checkout{
  background-color: $alert-green;
  &:visited{
    text-decoration: none;
  }
}

// Handling Variations in the small cart
dl.variation {
  margin: 0;
  padding: 0;

  dt, dd, p {
    display: inline-block;
    margin: 0;
    padding: 0;
    font-size: 0.8rem;
    line-height: 1.4;
  }
}

// Removing things from cart
.remove{
  text-decoration: none;
  line-height: 1;
  font-size: 0.5rem;
  margin-top: 0.2rem;
  padding: 0.15rem;
  display: block;
  float: right;
  vertical-align: middle;
  background-color: $alert-red;
  color: white;

  &:hover{
    color: white;
    background-color: $alert-red;
    text-decoration: none;
  }
}